{-# OPTIONS_GHC -fplugin UIO #-}
module Test.UIO.MultiModule where

import Data.IORef

import UIO
import Test.UIO.MultiModule.Callee

testMultiModule :: IO ()
testMultiModule = do
  r <- runUIO caller
  12 <- readIORef r
  pure ()

--TODO: I think this should fail because callee should get inlined here, and then CSE should take place, and it should find multiple newMutVar# operations taking the same state token as input, and they should be CSE'd away.  However, that doesn't seem to happen.  The callee might need a different internal structure to be susceptible to CSE.
caller :: UIO (IORef Int)
caller = do
  callee
  callee
